# Protokoll
- 1. Treffen des Softwareentwicklungsprojektes (G6) im SoSe 2025
- Datum: 25.03.2025
- Beginn des Treffens: 14:15 Uhr
- Ort: A0-22 und per Videokonferenz https://glight.hs-bochum.de/b/ben-6k4-nxa
 
# Teilnehmer:innen
- Benno Schmidt (A0-22), benno.schmidt@hs-bochum.de
- Leon Behler (online), leon.behler@stud.hs-bochum.de
- Lena Labraimi (online), lena.pfeil@stud.hs-bochum.de

Fehlend:
- Christian Danowski-Buhren, Christian.Danowski-Buhren@hs-bochum.de

# **TOP 1**: Allgemeines zum Softwareentwicklungsprojekt
- Blick ins Modulhandbuch
  - Prüfungsleistung bleibt genauer zu spezifizieren (wahrscheinlich Dokumentationsarbeiten im weiteren Sinne) -> **ToDo**: Benno Schmidt
- Vier Projektvorschläge (siehe unter TOP 3)

# **TOP 2**: Genutzte Werkzeuge
- Discord zur Kommunikation
  - Alle Projektteilnehmer:innen haben bereits einen Discord-Account :-)
- GitLab (Protokolle im Markdown-Format, Issues, Wiki mit Doku, Quellcode) 
  - GitLab-Zugang: https://gitlab-ce.hs-bochum.de/ -> **ToDo:** Zugang sicherstellen 
  - Alle Projektteilnehmer:innen haben bereits einen Gitlab-Zugang! :-)
- Videoraum: https://glight.hs-bochum.de/b/ben-6k4-nxa 
- Online-Protokolle: edupad.ch  
- etc.

# **TOP 3**: Projektvorschläge
## Vorschlag 1: Web3dScans
- Projekt gemeinsam mit dem HLNUG (Hessisches Landesamt für Naturschutz, Umwelt und Geologie) in Wiesbaden
  - Das wäre ein Einstieg in ein bereits bestehendes Softwareentwicklungsprojekt.
  - Visualisierung eingescannter 3D-Modelle von "Steinen" und Fossilien (geologische Handstücke) zusammen mit  Leaflet-basierten Kartenanwendung
  - Anwendung basierend auf HTML/CSS und JavaScript, zudem XML/JSON, WMS und WFS, 3D-JS-Bibliothek für 3D-Ansicht
  - (Responsiver) Prototyp: http://geoinformatik-bochum.de/web3dscan/ (das ist nicht der letzte Stand / da geht vieles noch nicht, was in der jetzigen Version realisiert ist)
   
## Vorschlag 2: Interaktive VR-Anwendung
- noch zu definierende VR/AR-Anwendung 
- Umsetzung auf Basis der Unity Engine (d.i. eine Game-Engine) -> Spatial.io (https://www.spatial.io/)
  - Implementierung eigener Programmlogik (über Templates oder C#???, noch unklar) 
  - PC nötig 
  - "Pionierprojekt" (keine Vorarbeiten)
  - Spaß an VR wäre vorteilhafte Voraussetzung
  - Unterstützung durch Unity-Entwickler hätten wir.
  
## Vorschlag 3: ArcGIS Pro -> MetaQuest3
- Plugin von ESRI
- Hier wäre der konkrete Installations- und Arbeitsablauf zu realisieren.
- Interessant wäre die Ergänzung weiterer Funktionen!
  - Auch hier: PC nötig, und eine Game-Engine ist wieder mit im Spiel.
  - Z. B..: ArcGIS Maps SDK for Unreal Engine | Esri Developer: https://developers.arcgis.com/unreal-engine/
  - Genaue Projektinhalte wäre zu definieren! (Projektidee noch unschärfer definiert als Vorschlag 1 und 2, aber hochgradig praxisrelevant!!)
  
## Vorschlag 4: "Intelligente Karte"
- Realisierung: HTML/CSS + JavaScript!! (z. B. Leaflet oder OpenLayers)
- Abfrage von Kontextinformation (Ort, Ereignisse, Landnutzung, ...) über geeignete "Sensoren" und Dienste via JavaScript
- prototypische Beispiele wäre währtend des Semesters umsetzen!
  
# **TOP 4**: Hausaufgabe
- Nachdenken, welches der vier Projekte am interessantesten ist. -> **ToDo**: alle Studierenden
  - Abstimmung (spätestens) beim nächsten Treffen.
  
# **TOP 5**: Verschiedenes
- Dieses erste Protokoll wird per E-Mail an die Teilnehmer:innen versendet. (Zukünftig Bereitstellung der Sitzungsprotokolle über GitLab). 
 
Ende des Treffens: 15:45 Uhr

Nächstes Treffen: Di. 01.04.2025, 14:15 Uhr im A0-22. (Änderungen möglich; Mitteilungen beachten!)
Zuvor treffen wir uns morgen Mi. 26.03.2025 zur Lehrveranstaltung "Virtuelle Realität" im A0-22.
