# Protokoll
- Treffen Nr. 3 des Softwareentwicklungsprojektes (G6) im SoSe 2025
- Datum: 08.04.2025
- Beginn des Treffens: 14:15 Uhr
- Ort: A0-22 und per Videokonferenz: https://glight.hs-bochum.de/b/ben-6k4-nxa
 
# Teilnehmer:innen
- Benno Schmidt (A0-22)
- Leon Behler (A0-22)
- Lena Labraimi (online)
- Christian Danowski-Buhren (A0-22)
- Pia Melina Rolf (A0-22)

Fehlend:
keiner

# **TOP 1**: Organisatorisches zum Softwareentwicklungsprojekt
- Kollaboratives Online-Protokoll der heutigen Sitzung in den "Geteilten Notizen" des BBB-Videoraums (landet dann im GitLab; s. u.)
  - Protokoll ist stets zu prüfen, wird in der jeweils folgenden Sitzung genehmigt durch Projektbeteiligte! 
- Ausgewählt als Projekt im SoSe 2025: TangibleSim (vgl. Vorschlag 5 der letzten Sitzung)
- Discord-Channel: https://discord.com/channels/1328444796733489192/1354536736851497041 (#tangiblesim des Labors für Geovisualisierung) 
- GitLab-Zugang: https://gitlab-ce.hs-bochum.de/ 
 - Christian hat neue Gitlab-Gruppe "web3d" angelegt, und direkt alle Teinlehmer:innen eingeladen (mit Rolle "Maintainer", Benno und Christian sind "Owner" mit allen Rechten). Link  https://gitlab-ce.hs-bochum.de/web3d/tangiblesim 
    - Hinweise zu git Klonen und co:  Christian nutzt SourceTree zwecks git clone, push, pull und co. Geht aber auch via Kommandozeile, Visual Studio integriert usw.. Via HTTPS Schnittstelle beim Klonen des Repos: https://gitlab-ce.hs-bochum.de/web3d/tangiblesim.git moodle credentials parat haben um pull/push durchzuführen. 
    @ALL: Bitte prüft das git Setup auch einmal bei euch und meldet euch bei Christian, so es Fehler gibt. Ggf. werden statt gitlab role "Developer" auch "Maintainer" Rechte benötigt, um auf den main branch pushen zu dürfen. 
    Nachtrag Christian: In der Tat werden "Maintainer" Rechte benötigt, um in gitlab-Projekten auch auf den main-branch pushen zu dürfen (mit "Developer" kann ein git push nur auf andere branches erfolgen - zumindest gemäß Standardkonfig)
- Bezug zur Masterarbeit von Pia Melina Rolf und anderen Aktivitäten im Fachbereich G
- Weitere Projektbeteiligte: Bernd Klemt (Hardware), Nathalie Küppers (betreibt AR Sandbox).

# **TOP 2**: Projektabgrenzung
- Mission Statement (noch etwas holprig...):
  - Es geht zunächst darum, per Tiefenkamera (RGB- und Tiefenbild) Situationen über einer Arbeitsfläche zu erfassen (z. B. Hände, Zeigestab, aufgestellte Objekte, Sandhöhen in der AR Sandbox etc.) und basierend auf der definierten Situation eine (Geo-) Simulation anzustoßen, deren Ergebnis lagerichhtig per Beamer (farbig) auf die Arbeitsfläche projiziert wird.  
  - Prüfen: Ist die Domäne zu eng oder zu breit oder genau richtig deginiert? -> **ToDo**  Wiedervorlage dieser Frage in der nächsten Woche
- Weiteres Vorgehen: Domänenbeschreibung, User-Storys, Hardware-Beschaffungen, Quellcode-Entwicklung (auf der Basis von Python)
- ... 

# **TOP 3**: Kurzfristig nötige Hardware-Beschaffungen
- Benötigte Hardware:
  - Rechner -> eigene Rechner
  - RGB-/Tiefenkamera -> eine weitere ist kurzfristig zu beschaffen **TODO** Benno Schmidt/Bernd Klemt, wahrscheinlich: Intel RealSense Depth Camera D415; darauf achten, dass Bilder abfragebar aus Programm heraus
  - Beamer/Display
  - Real erkennbare Objekte, z. B. Hand, Sand, Zeigestock, Klötze/Gebäude u. a.
  
- Benötigte Software
  - Treiber für die Kamera
  - Programmierumgebung, wahrscheinlich Python
  - Bildverarbeitungs-Bibliotheken (OpenCV?)
  - Simulationsmodelle (gibt's da schon was?)
  
# **TOP 4**: User Storys 
- User-Storys -> Wir haben heute erste Storys verfasst, siehe Anhang 2 dieses Protokolls
  - **ToDo** alle: Bis zur nächsten Sitzung gerne weitere Storys formulieren! 
    - Neue Storys können hier ergänzt werden: https://gitlab-ce.hs-bochum.de/web3d/tangiblesim/-/wikis/User_Stories 
  - Sichtung der Storys in der nächsten Woche.
- **ToDo**: Literatur raussuchen zu bereits umgesetzten Storys -> Benno Schmidt 

# **TOP 5**: Verschiedenes
- Pia Melina Rolf hat Xtion-Kamera (ohne Kiste mit Treiber-CD) für Testzwecke mit nach Hause genommen.
- Dieses Protokoll wird so wie die zukünftigen Sitzungsprotokolle über GitLab bereitgestellt. 
  - https://gitlab-ce.hs-bochum.de/web3d/tangiblesim/-/edit/main/Sitzungsprotokolle
 
Ende des Treffens: 15:00 Uhr

Nächstes Treffen: Di. 15.04.2025, 14:15 Uhr im A0-22. (Änderungen möglich; Mitteilungen beachten!)

# Anhang 1: Python-Programm zur Abfrage der Bilder der Asus Xtion Live Pro
- Importe vorab: 
  - pip install openni
  - pip install opencv-python

```python
import numpy as np
import cv2
from openni import openni2

# OpenNI initialisieren
openni2.initialize()  # Pfad zu OpenNI2 ggf. anpassen
dev = openni2.Device.open_any()

# Tiefe- und Farbstreams aktivieren
depth_stream = dev.create_depth_stream()
color_stream = dev.create_color_stream()

depth_stream.start()
color_stream.start()

try:
    while True:
        # Tiefenbild abrufen
        depth_frame = depth_stream.read_frame()
        depth_data = np.frombuffer(depth_frame.get_buffer_as_uint16(), dtype=np.uint16)
        depth_image = depth_data.reshape((depth_frame.height, depth_frame.width))

        # Farbbild abrufen
        color_frame = color_stream.read_frame()
        color_data = np.frombuffer(color_frame.get_buffer_as_uint8(), dtype=np.uint8)
        color_image = color_data.reshape((color_frame.height, color_frame.width, 3))

        # Tiefenbild skalieren und einfärben
        depth_colormap = cv2.applyColorMap(cv2.convertScaleAbs(depth_image, alpha=0.03), cv2.COLORMAP_JET)

        # Bilder nebeneinander anzeigen
        images = np.hstack((color_image, depth_colormap))
        cv2.imshow("Xtion Pro Live", images)

        # Beenden mit 'q'
        if cv2.waitKey(1) & 0xFF == ord('q'):
            break
finally:
    # Streams stoppen
    depth_stream.stop()
    color_stream.stop()
    openni2.unload()
    cv2.destroyAllWindows()`
```

## Anhang 2: User Storys

Story 1: Bestehende AR-Sandbox
 
1.1 (PMR) Als Nutzer:in möchte ich den Sand in dem Kasten bwegen können und direkt die Höhenveränderungen mit einer Farbänderungen sehen, damit ich die Höhe besser zuordnen kann.
1.2 (BS) Als Nutzer:in möchte ich es an einer frei festlegbaren Stelle im Sand regnen lassen. Es wird daraufhin direkt angezeigt, in welche Richtung das Wasser fließt.

Story 2: Lautstärke anzeigen (PMR)
2.1 Als Nutzer:in möchte ich den Untergrund beliebig bewegen und Gebäude, Straßen und Parks platzieren können und mit einer farblichen Einfärbung erkennen können, wie sich die Lautstärke an der Oberfläche ausbreitet, um ein Gefühl dafür zu bekommen, wie sich Schall ausbreitet.
2.2 Als Nutzer:in möchte ich den Untergrund beliebig bewegen und Geböude, Straßen und Parks platzieren können und mit einem Zeigestock zeigen, an welcher Stelle ich gerne die berechnete Lautstärke wissen möchte. Die berechnete Lautstärke soll über Audio-Ausgabe ausgegeben werden, damit jeder um den Tisch hören kann wie laut es an der Stelle des Zeigestocks ist.
  
Story 3: Terrain formen (BS) 
Als Nutzer:in möchte ich eine vordefinierte Geländesituation im Sandkasten herstellen. Das System unterstützt mich dabei, in dem es den Sand an den Stellen rot einfärbt, an denen noch zuviel Sand liegt, und dor blau, wo zu wenig liegt. Dort, wo die Situation stimmt, ist alles grün dargestellt.  

Story 4: Klima/Wärme (PMR)
Als Nutzer:in möchte ich den Untergrund beliebig bewegen und Gebäude, Straßen und Parks platzieren können und mit einer farblichen Einfärbung erkennen können, wie sich die Wärme in der Umgebung verteilt, um Hitzeinseln und kühlende Effekte graphisch verstehen zu können.

Story 5: Freiraumplanung (BS) 
Als Nutzer:in möchte ich auf einer Papierkarte Objekte (z. b. Miniatur-Hausmodelle oder Bäume) positionieren und die Positionen in mein GIS übernehmen.  

Story 6: Messen (LB)
Als Nutzerin möchte ich in georeferenzierten Anwendungen die Möglichkeit haben, Abstände zu messen

Story 7: Höhenprofil erstellen (BS)
Als Nutzer:in möchte ich in im Sand zwei Bauklötze aufstellen und das Höhenprofil für die durch die beiden Klörtze definierte Profillinie auf einem externen Monitor darstellen.
