# Protokoll
- Treffen Nr. 7 des Softwareentwicklungsprojektes (G6) im SoSe 2025
- Datum: 19.05.2025
- Beginn des Treffens: 13:45 Uhr
- Ort: https://glight.hs-bochum.de/b/ben-6k4-nxa 
 
# Teilnehmer:innen
- Benno Schmidt
- Leon Behler
- Pia Melina Rolf
- Christian Danowski-Buhren
- Lena Labraimi

Fehlend:
/

# **TOP 1**: Organisatorisches
- Kollaboratives Online-Protokoll der heutigen Sitzung: https://edupad.ch/p/SVwevDuv5V
- Nächstes Plenums-Treffen: Findet morgen statt (s. u.)

# **TOP 1**: Code-Vorstellung
- Pia Melina Rolf hat heute ihren bisherigen Programmcode vorgestellt.
  - GitHub-Repository: https://github.com/rolfp01/AR-Sandbox
- Arbeiten mit dem GitHub-Repo von Pia Melina Rolf: Klonen z. B. per Git-Kommandozeilentool oder GitHubDesktop oder TortoiseGit oder ...
- Umsetzung in Python, da dort offenbar beste Unterstützung der Kameraabfrage und einfache Nutzbarkeit von Bildverarbeitungsfunktionen (siehe dazu auch letzte Protokolle)
  - Derzeit verwendet: Python **3.11**
- Aktuell: "Funktionsorientierte" Umsetzung in Python (nicht objektorientiert)
- 3 wesentliche Python-Komponenten
  - DataCalculation: Simulation ausführen, z. B. Lärmsimulation, aber auch Höhenwerte im Sand extrahieren, Gebäudeerkennung
  - DataRead: Abfrage Kamerabild, inkl. Zeigestab-Erkennung?
  - DataShow: Ergebnisanzeige
  - app.py führt auf oberster Ebene alles zuammen (ist eine konkrete Applikation)
- Es gibt die Möglichkeit, statt einer eigenen app.py zu erstellen, auch eigene "Themes" zu erstellen (siehe Quellcode app.py, aktuell Zeile 226ff.), die in HTML-Seite angezeigt werden ("index.html")
- Anwendung auch ohne Tiefenkamera betreibbar, nur mit einer herkömmlichen RGB-Kamera lauffähig. -> Nicht-funktionale Anforderung; unter https://gitlab-ce.hs-bochum.de/fachbereich-geodaesie/gi-projekte/tangiblesim/-/wikis/User_Stories ergänzt.
  - Graustufenbild ist abfragbar über grayPicture.py (unter DataCalculation)
- Während der Demonstration der Anwendung fiel (eider einmal) auf: Insb. das Tiefenbild - hier der alten Asus-Kamera - flackerte sehr.
  - Ursachen? (Mattes Material?? Beleuchtung? -> unklar!) 
  - Abhilfe möglich? (Bildstabilisierung durch Anwendung eines Filters?)
  - Hier besteht wahrscheinlich weiterer Forschungsbedarf.
- Detail-Fragen (vgl. TOP 3 des letzten Protokolls):
  - Wo lege ich wie fest, welche konkrete Kamera-Hardware verwendet wird? -> Quellcode studieren (app.py?)
  - Festlegung des "Arbeitsbereichs" / Georeferenzierung -> weiterhin offen
  - Wie bringe ich der Anwendung bei, zwei Positionen für eine Streckenmessung festzulegen, z. B. durch Zeigen mit Finger, Positionieren besonderer Marker in *Arbeitsbereich* o. ä. -> weiter offen
- Hinweis: Verwendete Third-Party-Bibliotheken (und Versionsnummern) sollten in zentraler Doku-Datei/README aufgeführt werden (mit Versionsnummer)
- Zentrale Fragen:
  - Inwieweit können wir da aus dem Softwareentwicklungsprojekt heraus Dinge beisteuern?
  - Wie können wir darauf aufbauend eine eigene Anwendung realisieren?
  - An welchen Stellen lässt sich der Code möglicherweise besser gestalten?
  - Wie organisieren wir unsere Zusammenarbeit am Besten?
  - ...
  - -> Nächster Schritt: anwendung auschecken und auf eigenem Gerät ans Laufen bringen!
   
Ende des Treffens: 14:41 Uhr

Nächstes Treffen: Di. 20.05.2025, 14:15 Uhr im A0-22
